function tboot=BootFGLS(yin,xin,zin,Uin,ta,numboot,Type,ConsT,ConsN)

%it is assumed that the analysis is conditional on covariates x,z,U. 
%yin is a n*T by numboot matrix of dependent variables. Numboot is the
%number of bootstrap replications. yin is generated under the null
%hypothesis by resampling unconstrained residuals and regenerating the
%dependent variable.

T1=zeros(numboot,1);

for i=1:numboot
    Y=yin(:,i);
    X=xin;
    Z=zin;
    if isempty(Uin)
       U=[];
    else
        U=Uin;
    end
    %Estimate Parameters and Construct Test Statistics
    [GammaHatGLS,GammaVarGLS]=GLS(Y,X,Z,U,Type,ConsT,ConsN);
    T1(i)=abs(GammaHatGLS/sqrt(GammaVarGLS));
end

sig=1-2*(1-normcdf(ta));
T1=sort(T1);
tboot=T1(floor(sig*numboot));
return