function [SigmaHatT,SigmaHatN]=Comp_SHT(M,y,n,T,ConstT,ConstN)
%ConstT is a T by T logical matrix with an entry of 1 if the corresponding
%serial correlation coefficient is estimated unconstrained
%Constn is a n by n logical matrix with an entry of 1 if the corresponding
%cross-sectional correlation coefficient is estimated unconstrained

  epsilon_td=M*y;
  eT=reshape(epsilon_td,n,T);
  eN=eT';
  SigmaHatT=eT'*eT;
  SigmaHatN=eN'*eN;
  for i=1:T
      for j=1:i
          if ConstT(i,j)
              Mii=M(((i-1)*n+1):i*n,((i-1)*n+1):i*n);
              Mjj=M(((j-1)*n+1):j*n,((j-1)*n+1):j*n);
              wij=tr(Mii*Mjj);
              SigmaHatT(i,j)=SigmaHatT(i,j)/wij;
              SigmaHatT(j,i)= SigmaHatT(i,j);
          else
              SigmaHatT(i,j)=0;
              SigmaHatT(j,i)=0;
          end
      end
  end
  for i=1:n
      for j=1:i
          if ConstN(i,j)
              Uniti=[zeros(i-1,1);1;zeros(n-i,1)];
              Unitj=[zeros(j-1,1);1;zeros(n-j,1)];
              Indexii=logical(kron(eye(T),Uniti*Uniti'));
              Indexjj=logical(kron(eye(T),Unitj*Unitj'));
              Mii=M(Indexii);
              Mjj=M(Indexjj);
%              wij=tr(Mii*Mjj);
              wij=Mii'*Mjj;
              SigmaHatN(i,j)=SigmaHatN(i,j)/wij;
              SigmaHatN(j,i)= SigmaHatN(i,j);
          else
              SigmaHatN(i,j)=0;
              SigmaHatN(j,i)=0;
          end
      end
  end
return
